/* cdftable -- create a Candis file from a table of numbers */
#include <stdio.h>
#include <math.h>
#include "cdfhdr.h"

#define MAXVARS 100

static char buff[HBMAX][LINE];
static float *vbuff;
static long nvbuff;
static int nvars;
static float index;

main(argc,argv)
int argc;
char *argv[];
{
  int loop;

/* check command line */
  if (argc == 1) {
    fprintf(stderr,"Usage: cdftable name1 name2 ...\n");
    exit(1);
  }
  nvars = argc - 1;
  if (nvars > MAXVARS) {
    fprintf(stderr,"cdftable: a maximum of %d variables allowed\n",MAXVARS);
    exit(1);
  }

/* make header and write */
  nullhdr(buff,HBMAX,"float");
  addcline(buff,HBMAX,"cdftable:\n");
  addfld(buff,HBMAX,'v',"index",1.,0.,'l',0);
  for (loop = 1; loop <= nvars; loop++) {
    addfld(buff,HBMAX,'v',argv[loop],1.,0.,'l',0);
  }
  puthdr(stdout,buff,HBMAX);

/* allocate buffer space */
  nvbuff = elemcnt(buff,HBMAX,'v');
  vbuff = getbuff(nvbuff);

/* write a null static slice */
  putslice(stdout,0,vbuff);

/* loop on input */
  index = 0.;
  while (1) {
    vbuff[0] = index;
    index += 1.;
    for (loop = 1; loop < nvbuff; loop++) {
      if (scanf("%f",vbuff + loop) == EOF) {
        exit(0);
      }
    }

/* write a variable slice */
    putslice(stdout,nvbuff,vbuff);
  }
  exit(0);
}
