/* this routine just jackets the standard pgraf routine scale      */
/* the arguments given are the same as for scale with the addition */
/* of the additional final argument (the pointer to the # of tics) */
/* and the difference that coarse (now of type int) represents the */
/* % that the top value may be greater than the true maximum in    */
/* order that the axes are set to a more convenient number.        */
#include <math.h>
#include "pgraf.h"

pscale(n,coarse,array,max,min,tic)
int n,coarse,*tic;
float *max,*min,*array;
{
  static int preference[] = {
    100,50,25,20,10,5,1 };
  static int nump = 7;
  float tmax,tmin;
  int i,j;
  int stuff;
  float emax,emin;
  int dif;
  float max_plus_percent,min_minus_percent;

  /* first see what we get out of a coarse of 0 from scale */
  scale(n,0.,array,max,min);

  /* hack off the exponents then multiply by 10 */
  if(*max != 0.) tmin = (int)(*min/pow(10.,(float)floor(log10(fabs(*min)))-1));
  else tmax = 0;
  if(*min != 0.) tmax = (int)(*max/pow(10.,(float)floor(log10(fabs(*max)))-1));
  else tmin = 0;

  /* record what the powers we just stripped off were */
  if(*max != 0) emax = (float)floor(log10(fabs(*max)));
  else emax = 0;
  if(*min != 0) emin= (float)floor(log10(fabs(*min)));
  else emin = 0;

  /* try to find a good number for max & min within the required % */
  /*if(*max > 0) max_plus_percent = (1.+(float)coarse/100.)*tmax;
  else max_plus_percent = (1.-(float)coarse/100.)*tmax;
  if(*min > 0) min_minus_percent= (1.-(float)coarse/100.)*tmin;
  else min_minus_percent = (1.+(float)coarse/100.)*tmax; */

  max_plus_percent = *max + (*max-*min)*(float)coarse/100.;
  min_minus_percent = *min- (*max-*min)*(float)coarse/100.;

  /* now loop over preferred values setting things the highest preference */
  /* we can get away with.                                                */
  /* first try this for MAX */
  for( i = 0; i < nump ; i++){
    stuff = ceil(tmax/(float)preference[i])*preference[i];
    if(stuff <= max_plus_percent) break;
  }
  *max = stuff*pow(10.,emax - 1.);
  /* try the one that worked for max first then use previous preferences */
  for( i = 0; i < nump ; i++){
    stuff = floor(tmin/(float)preference[i])*preference[i];
    if(stuff >= min_minus_percent) break;
  }

  *min= stuff*pow(10.,emin-1.);

  dif = *max - *min;
  /* finally try to set the number of tics appropriately */
  for(i = 0 ; i < nump ; i ++){
    for(j = 15 ; j >= 5 ; j--){
      if(dif%(j*preference[i]) == 0) break;
    }
  }
  *tic = j+1;
  return;
}
