/* rawget2.h -- include file that defines structure of single time
 * P-3 aircraft slow tape -- data in ascii form from Dave Jorgensen
 */

#define NVARS 23

struct p3slowblock {
  int ac;                            /* aircraft (42 or 43) */
  int mo,dy,yr,hr,mn,sc;             /* date and time */
  float lad,lod,lam,lom;             /* lat-lon degs & mins */
  float hd;                          /* heading */
  float pc;                          /* pitch */
  float rl;                          /* roll */
  float ps;                          /* static pressure (mb) */
  float ta,td;                       /* temp, dewpt (C) */
  float gs;                          /* ground speed (m/s) */
  float tk;                          /* track angle */
  float ws,wd;                       /* wind speed (m/s) and direction */
  float rd,rs,ru;                    /* down, side, up radiometers (C) */
  float wz;                          /* vertical wind (m/s) */
  float wgs;                         /* vertical ground speed (m/s) */
  float was;                         /* vertical air speed */
  float lw;                          /* J-W liquid water (g/m^3) */
  float tas;                         /* true air speed (m/s) */
  float ga,pa;                       /* Geopotent & press alt */
  float av1,av2;                     /* INE #1,#2 vert accel */
};
