/* fzout -- This program reads the buffer files created by fzin
 * and pipes them sequentially to standard output.  The buffer
 * files are deleted when no longer needed.
 */

#include <stdio.h>
#define BSIZE 100
#define BUFFERS 500

char buffer[BSIZE];
int current_file;
char filename[80];
int sleep_int;
int num;
char command[80];
FILE *fhandle;

main(argc,argv)
int argc;
char *argv[];
{

/* check arguments */
  if (argc != 4) {
    fprintf(stderr,"Usage: fzout file_prefix first_file sleep_int\n");
    exit(1);
  }
  current_file = atoi(argv[2]);
  sleep_int = atoi(argv[3]);

/* loop forever */
  while (1) {

/* construct current file name */
    sprintf(filename,"%s%03d",argv[1],current_file++);
    if (current_file >= BUFFERS) current_file = 0;

/* try opening it -- sleep for a while and retry if failure */
    while ((fhandle = fopen(filename,"r")) == NULL) sleep(sleep_int);
    
/* transfer contents to standard output */
    while ((num = fread(buffer,sizeof(char),BSIZE,fhandle)) > 0) {
      fwrite(buffer,sizeof(char),num,stdout);
    }

/* close the current file and flush the output */
    fclose(fhandle);
    fflush(stdout);

/* delete the current file */
    sprintf(command,"rm -f %s",filename);
    system(command);
  }
}
