/* getarea.c -- Replacement for getstream for direct read of area
 * files.
 */

#include <stdio.h>
#include <math.h>
#include "mcidas.h"

static int gottoend = 0;

getstream(pointer,number)
char *pointer;
int number;
{
  if (gottoend) return(-1);
  if (fread(pointer,1,number,stdin) != number) {
    fprintf(stderr,"getstream: unexpected eof\n");
    gottoend = 1;
    return(-1);
  }
  return(0);
}

resetstream()
{
  /* do nothing here */
  return(0);
}

short getshort()
{
  unsigned char buff[2];
  short word;

/* convert 2 bytes into a short integer */
  if (getstream(buff,2) == -1) return ((short)0);

/* this should work for both VAXs and others */
  word = buff[1] + 256*buff[0];
  return(word);
}

long getword()
{
  unsigned char buff[4];
  long word;

/* convert 4 bytes into a long word */
/* this routine assumes that a long is 4 bytes */
  if (getstream(buff,4) == -1) return((long)0);

/* this should work for both VAXs and others */
  word = buff[3] + 256*buff[2] + 65536*buff[1] + 16777216*buff[0];
  return(word);
}

getsync()
{
  unsigned char buff[8];
  int goop;
  int trycount;

/* get the next 8 bytes and test for sync pattern */
  trycount = 0;
  if (getstream(buff,8) == -1) return(-1);
  while (1) {
    if (buff[0] == 0 && buff[1] == 0xff && buff[2] == 0 && buff[3] == 0xff &&
         buff[4] == 0 && buff[5] == 0xff && buff[6] == 0 &&
         buff[7] == 0xff) return(trycount);
    else {

/* we didn't get a sync -- shift, add a byte, and retest */
      trycount++;
      if (trycount >= TRYMAX) return(trycount);
      for (goop = 1; goop < 8; goop++) buff[goop - 1] = buff[goop];
      if (getstream(buff + 7,1) == -1) return(-1);
    }
  }
}

getskip(number)
int number;
{
  int loop;
  if (gottoend) return(-1);

/* loop on points required */
  for (loop = 0; loop < number; loop++) {
    if (getchar() == EOF) {
      gottoend = 1;
      fprintf(stderr,"getskip: unexpected eof\n");
      return(-1);
    }
  }
  return(0);
}
