/* convert from year-month-day to julian day
 * derived from NSSDC CDF Implementer's Guide, Version 1
 * by Michael L. Gough
 */
#include <stdio.h>

long julian_date(y,m,d)
long y,m,d;
{
  long jd;
  jd = 367*y - 7*(y + (m + 9)/12)/4
       - 3*((y + (m - 9)/7)/100 + 1)/4
       + 275*m/9 + d + 1721029;
  return(jd);
}

/* convert from julian day to year-month-day */

gregorian_date(jd,y,m,d)
long jd;
int *y,*m,*d;
{
  long i,j,k,l,n;
  l = jd + 68569;
  n = 4*l/146097;
  l -= (146097*n + 3)/4;
  i = 4000*(l + 1)/1461001;
  l -= (1461*i/4 - 31);
  j = 80*l/2447;
  k = l - 2447*j/80;
  l = j/11;
  j += (2 - 12*l);
  i = 100*(n - 49) + i + l;
  *y = i;
  *m = j;
  *d = k;
}
