/* mcselect.c -- This program reads the pc-mcidas data stream and
 * selects headers for particular data products.  Specialized
 * subroutines then read the stream to retrieve and analyze each
 * product.  The pc-mcidas data stream is assumed to be on the
 * standard input.
 */

#include <stdio.h>
#include <math.h>
#include "mcidas.h"

main()
{
  struct mcpacket *packet;
  struct mcpacket *getpacket();

/* loop forever on packet read, selecting only rcode = 0 and thread =
   THREAD packets */
  while (1) {
    if ((packet = getpacket()) == NULL) exit(0);
    if (packet->thread != THREAD) {
      /*
      fprintf(stderr,"mcselect: packet with thread %d ignored\n",
           packet->thread);
	   */
      continue;
    }
    if (packet->r_code != 0) continue;

/* satellite images - lwtoa3 */
    if (strncmp(packet->data,"LWTOA3",6) == 0) getlwtoa3(packet->data);
  }
}
