%{
/* nwssa -- This lex routine converts
 * surface data to common data format.
 */
#include "cdfhdr.h"
char station[30],time[30],wnd[30],temp[30],dewpt[30],altset[30],ceiling[30];
char month[30],day[30],hour[30],zone[30],year[30];
float mon;
int american;
int dategot = 0;
int clr,sct,bkn,ovc,xxx,rain,snow,rshow,sshow,tstorm,ice,smoke,fog,haze;
char *pop();
int sptr = 0;
#define SAMAX 500
extern struct satable {    /* table containing station info */
  float num;
  char station[4];
  float lat,lon;
  float elev;
} salist[SAMAX];
extern int listmax;        /* actual number of stations in list */
extern float bad,badlim;   /* bad data values */
extern char hbuff[HBMAX][LINE]; /* cdf header buffer */
extern long nvbuff;        /* variable slice buffer length */
extern float *vbuff;       /* variable slice buffer pointer */
extern float *cdfstn,*cdfdate,*cdfmonth,*cdfyear,*cdfhour,*cdflat,*cdflong,
     *cdfelev,*cdftemp,*cdfdewpt,*cdfu,*cdfv,*cdfaltset,*cdfceiling,
     *cdfwx,*cdfmixrat;    /* variable field pointers */
%}
%Start date begin body wind fin sa
%%
			BEGIN begin;
<fin,wind>"\n"		{BEGIN begin; action(); /* correct restart */}
<date>"\n"		{BEGIN begin; datelist(); /* date restart */}
"\n"			{BEGIN begin; error(); /* error restart */}
<begin>[A-Z][a-z][a-z]	{BEGIN date; /* this is a date line */}
<date>[A-Z][a-z][a-z]	{strcpy(month,yytext);}
<date>[A-Z][A-Z][A-Z]	{strcpy(zone,yytext);}
<date>[0-9]+:[0-9:]+	{strcpy(hour,yytext);}
<date>[0-9][0-9][0-9][0-9]	{strcpy(year,yytext);}
<date>[0-9][0-9]?	{strcpy(day,yytext);}
<begin>[A-Z]+		{strcpy(station,yytext); BEGIN sa; /* station */}
<sa>SA			{american = 1; /* regular american observation */}
<sa>[0-9][0-9][0-9][0-9]	{BEGIN body; strcpy(time,yytext); /* time */}
<body>AMOS		{; /* who cares? */}
<body>AWOS		{; /* who cares? */}
<body>ASOS		{; /* who cares? */}
<body>AUTOB		{;}
<body>BLO		{;}
<body>COR		{;}
<body>[0-9]?[0-9]?MAS	{;}
<body>CLR		{clr = 1; /* it is clear */}
<body>DSP		{clr = 1; /* esta despacio */}
<body>DPS		{clr = 1;}
<body>DESP		{clr = 1;}
<body>"-"?SCT		{strcpy(ceiling,pop()); sct = 10; /* cloud states */}
<body>MNU		{strcpy(ceiling,pop()); sct = 10;}
<body>"MNU/MNU"		{strcpy(ceiling,pop()); sct = 10;}
<body>"-"?BKN		{strcpy(ceiling,pop()); bkn = 20;}
<body>NUB		{strcpy(ceiling,pop()); bkn = 20;}
<body>"NUB/NUB"		{strcpy(ceiling,pop()); bkn = 20;}
<body>"-"?OVC		{strcpy(ceiling,pop()); ovc = 40;}
<body>CDO		{strcpy(ceiling,pop()); ovc = 40;}
<body>"NUB/CDO"		{strcpy(ceiling,pop()); ovc = 40;}
<body>[0-9]+"/"[0-9]+X[-+]?	{strcpy(ceiling,pop()); xxx = 80;}
<body>[0-9]*X[-+]?	{strcpy(ceiling,pop()); xxx = 80;}
<body>[0-9]+"/"[0-9]+TRW[-+]?	{tstorm = 800; /* precip */}
<body>[0-9]*TRW[-+]?	{tstorm = 800;}
<body>[0-9]+"/"[0-9]+RW[-+]?	{rshow = 100;}
<body>[0-9]*RW[-+]?	{rshow = 100;}
<body>[0-9]+"/"[0-9]+SW[-+]?	{sshow = 100;}
<body>[0-9]*SW[-+]?	{sshow = 100;}
<body>[0-9]+"/"[0-9]+IPW[-+]?	{sshow = 100;}
<body>[0-9]*IPW[-+]?	{sshow = 100;}
<body>[0-9]+"/"[0-9]+ZR[-+]?	{ice = 800;}
<body>[0-9]*ZR[-+]?	{ice = 800;}
<body>[0-9]+"/"[0-9]+ZL[-+]?	{ice = 800;}
<body>[0-9]*ZL[-+]?	{ice = 800;}
<body>[0-9]+"/"[0-9]+R[-+]?	{rain = 200;}
<body>[0-9]*R[-+]?	{rain = 200;}
<body>[0-9]+"/"[0-9]+L[-+]?	{rain = 200;}
<body>[0-9]*L[-+]?	{rain = 200;}
<body>[0-9]+"/"[0-9]+S[-+]?	{snow = 400;}
<body>[0-9]*S[-+]?	{snow = 400;}
<body>[0-9]+"/"[0-9]+IP[-+]?	{snow = 400;}
<body>[0-9]*IP[-+]?	{snow = 400;}
<body>[0-9]+"/"[0-9]+K[-+]?	{smoke = 1; /* visibility restrictors */}
<body>[0-9]*K[-+]?	{smoke = 1;}
<body>[0-9]+"/"[0-9]+H[-+]?	{haze = 2;}
<body>[0-9]*H[-+]?	{haze = 2;}
<body>[0-9]+"/"[0-9]+F[-+]?	{fog = 4;}
<body>[0-9]*F[-+]?	{fog = 4;}
<body>E?[0-9][0-9]V?[0-9][0-9]		{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>E?[0-9][0-9]V?[0-9][0-9]G[0-9][0-9][0-9]?	{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>"C/"				{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>"CALMA/"				{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>"MM/"				{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>[0-9][0-9]"M/"			{BEGIN wind;
					strcpy(wnd,yytext); /* get wind */
					strcpy(dewpt,pop()); /* get dew point */
					strcpy(temp,pop()); /* get temp */}
<body>[-0-9MEW]+	{push(yytext); /* save numeric string */}
<wind>[0-9]+		{strcpy(altset,yytext); BEGIN fin; /* alt set */}
.			{; /* get rid of everything else */}
%%
#define STMAX 10
char stack[STMAX][10];
float mr();

/* push string onto stack */
push(string)
char *string;
{
  if (sptr < STMAX) strcpy(stack[sptr++],string);
}

/* pop string off stack */
char nstr[1];
char *pop()
{
  if (sptr > 0) return(stack[--sptr]);
  else {
    nstr[0] = '\0';
    return(nstr);
  }
}

#define DIAG 0

/* take some action */
action()
{
  float ceilcalc(),timecalc(),altcalc(),tempcalc();
  float cl,wx,alt,hr,ux,uy,t,dp;
  float stnnum,lat,lon,elev;
/* compute the weather parameter */
  wx = sct + bkn + ovc + xxx + rain + snow + rshow + sshow + tstorm
       + ice + smoke + fog + haze;
  if ((wx == 0.) && (clr == 0)) wx = bad;
/* compute other parameters */
  windcalc(american,wnd,&ux,&uy);
  hr = timecalc(time);
  alt = altcalc(american,altset);
  t = tempcalc(american,temp);
  dp = tempcalc(american,dewpt);
  cl = ceilcalc(ceiling);
/* find lat, long, elev, and station number */
  tablesearch(station,&lat,&lon,&elev,&stnnum);
/* fill the slice buffer */
  *cdfstn = stnnum;
  *cdfdate = atoi(day);
  *cdfmonth = mon;
  *cdfyear = atoi(year);
  *cdfhour = hr;
  *cdflat = lat;
  *cdflong = lon;
  *cdfelev = elev;
  *cdftemp = t;
  *cdfdewpt = dp;
  *cdfmixrat = mr(dp,elev);
  *cdfu = ux;
  *cdfv = uy;
  *cdfaltset = alt - 1000.;
  *cdfceiling = cl;
  *cdfwx = wx;
#if DIAG
/* diagnostic printouts */
  printf("*****************************************************\n");
  if (american) printf("american station = %s\n",station);
  else printf("mexican station = %s\n",station);
  printf("stn num = %f;  lat = %f;  long = %f;  elev = %f\n",
       stnnum,lat,lon,elev);
  printf("date = %s;  month = %s (%f);  year = %s\n",day,month,mon,year);
  printf("time = %s\n",time);
  printf("hour = %f\n",hr);
  printf("temp = %s\n",temp);
  printf("dewpt = %s\n",dewpt);
  printf("t & dp: %f %f\n",t,dp);
  printf("wind = %s\n",wnd);
  printf("ux = %f;  uy = %f\n",ux,uy);
  if (strcmp(altset,"") != 0) printf("altset = %s\n",altset);
  printf("alt set = %f\n",alt);
  if (clr) printf("clear\n");
  if (smoke) printf("smoke\n");
  if (fog) printf("fog\n");
  if (xxx) printf("sky obscured\n");
  if (sct) printf("scattered clouds\n");
  if (bkn) printf("broken clouds\n");
  if (ovc) printf("overcast\n");
  if (ice) printf("freezing rain\n");
  if (tstorm) printf("thunderstorm\n");
  if (rain) printf("raining\n");
  if (snow) printf("snowing\n");
  if (rshow) printf("rain showers\n");
  if (sshow) printf("snow showers\n");
  printf("wx = %f\n",wx);
  if (strcmp(ceiling,"") != 0) printf("ceiling = %s\n",ceiling);
  printf("cl = %f\n",cl);
#else
/* write a variable slice only with a date stamp */
  if (dategot) putslice(stdout,nvbuff,vbuff);
#endif
  init();
}

/* error in input */
error()
{
#if DIAG
  printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  printf("error on station = %s\n",station);
#endif
  init();
}

/* initialization routine */
init()
{
  sptr = 0;
  american = 0;
  clr = sct = bkn = ovc = xxx = 0;
  rain = snow = rshow = sshow = tstorm = ice = 0;
  haze = smoke = fog = 0;
  strcpy(station,"");
  strcpy(time,"");
  strcpy(wnd,"");
  strcpy(temp,"");
  strcpy(dewpt,"");
  strcpy(altset,"");
  strcpy(ceiling,"");
}

/* list date */
datelist()
{
#if DIAG
/* diagnostic prints */
  printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n");
  printf("hour = %s %s\n",hour,zone);
  printf("day, month, year = %s %s %s\n",day,month,year);
#endif
/* set dategot flag */
  dategot = 1;
/* compute the month */
  if (strcmp(month,"Jan") == 0) mon = 1.;
  else if (strcmp(month,"Feb") == 0) mon = 2.;
  else if (strcmp(month,"Mar") == 0) mon = 3.;
  else if (strcmp(month,"Apr") == 0) mon = 4.;
  else if (strcmp(month,"May") == 0) mon = 5.;
  else if (strcmp(month,"Jun") == 0) mon = 6.;
  else if (strcmp(month,"Jul") == 0) mon = 7.;
  else if (strcmp(month,"Aug") == 0) mon = 8.;
  else if (strcmp(month,"Sep") == 0) mon = 9.;
  else if (strcmp(month,"Oct") == 0) mon = 10.;
  else if (strcmp(month,"Nov") == 0) mon = 11.;
  else if (strcmp(month,"Dec") == 0) mon = 12.;
  else mon = 0.;
/* warning if time zone not gmt */
  if (strcmp(zone,"GMT") != 0) {
    fprintf(stderr,"nwssa: warning! time zone on date not GMT\n");
    fprintf(stderr,"                date phase error possible\n");
  }
}

#include <ctype.h>
#include <math.h>
#define ANGLECON 0.17453
#define KTOMPS 0.5128

/* calculate x and y wind components in m/s */
windcalc(us,wstring,u,v)
int us;
char *wstring;
float *u,*v;
{
  char temp[5];
  int start;
  float speed,direction;
/* check for "C/" or "CALMA" */
  if (wstring[0] == 'C') {
    *u = *v = 0.;
    return;
  }
/* check for minimum string length */
  if (strlen(wstring) < 4) {
    *u = *v = bad;
    return;
  }
/* get wind direction */
  if (wstring[0] == 'E') wstring += 1;
  if (isdigit(wstring[0]) && isdigit(wstring[1])) {
    temp[0] = wstring[0];
    temp[1] = wstring[1];
    temp[2] = '\0';
    direction = ANGLECON*atoi(temp);
  }
  else {
    *u = *v = bad;
    return;
  }
/* get wind speed */
  if (wstring[2] == 'V') start = 3;
  else start = 2;
  if (isdigit(wstring[start]) && isdigit(wstring[start + 1])) {
    temp[0] = wstring[start];
    temp[1] = wstring[start + 1];
    temp[2] = '\0';
    speed = KTOMPS*atoi(temp);
  }
  else {
    *u = *v = bad;
    return;
  }
/* compute components */
  *u = -speed*sin(direction);
  *v = -speed*cos(direction);
}

/* compute the hour preceeding */
float timecalc(tstring)
char *tstring;
{
  char hstr[3],mstr[3];
  float h,m;
  hstr[0] = tstring[0];
  hstr[1] = tstring[1];
  hstr[2] = '\0';
  mstr[0] = tstring[2];
  mstr[1] = tstring[3];
  mstr[2] = '\0';
  h = atoi(hstr);
  m = atoi(mstr);
  h += m/60. -.5;
  h = (int) h;
  if (h < 0.) h += 24.;
  if (h > 23.) h -= 24.;
  return(h);
}

#define ALTCON 33.86

/* compute altimeter setting in mb */
float altcalc(american,astring)
int american;
char *astring;
{
  float alt;
/* check for bum data */
  if (strlen(astring) != 3) return(bad);
/* american -- value in inches of mercury */
  if (american) {
    alt = atoi(astring);
    if (alt > 500.) alt += 2000.;
    else alt += 3000.;
    alt /= 100.;
    alt *= ALTCON;
  }
/* metric -- mb */
  else {
    alt = atoi(astring);
    if (alt > 500.) alt += 9000.;
    else alt += 10000.;
    alt /= 10.;
  }
  return(alt);
}

/* compute a temperature */
float tempcalc(american,tstring)
int american;
char *tstring;
{
  float t;
/* check for bad data */
  if ((isdigit(tstring[0])) || (tstring[0] == '-')) t = atoi(tstring);
  else return(bad);
/* american (f) data */
  if (american) t = (t - 32.)/1.8;
/* if mexican, check for weird values */
  else {
    if (t > 49.9) t = bad; /* for obscure Mexican obs */
  }
  return(t);
}

#define CEILCON 0.03048

/* compute the ceiling in kilometers */
float ceilcalc(cstring)
char *cstring;
{
  char temp[100];
  int loop,poop;
  loop = poop = 0;
  while (cstring[poop] != '\0') {
    if (isdigit(cstring[poop])) {
      temp[loop++] = cstring[poop];
    }
    poop++;
  }
  temp[loop] = '\0';
  if (strlen(temp) == 0) return(bad);
  else return((float) (CEILCON*atoi(temp)));
}

/* search the station data table for information */
tablesearch(station,lat,lon,elev,snum)
char *station;
float *lat,*lon,*elev,*snum;
{
  int loop;
  *lat = *lon = *elev = *snum = bad;
  for (loop = 0; loop < listmax; loop++) {
    if (strcmp(station,salist[loop].station) == 0) {
      *lat = salist[loop].lat;
      *lon = salist[loop].lon;
      *elev = salist[loop].elev;
      *snum = salist[loop].num;
      return;
    }
  }
}

/* compute approximate mixing ratio in g/kg given dp in C and elev in m */
#define SURF_PRES 1000.
#define SCALE_HT 7.
#define C_TO_K 273.15
#define EPSILON 623.
float mr(dp,elev)
float dp,elev;
{
  float vpsat,pres,es();
  if ((fabs(dp) > badlim) || (fabs(elev) > badlim)) return(bad);
  pres = SURF_PRES*exp(-elev/SCALE_HT);
  vpsat = es(dp + C_TO_K);
  return(EPSILON*vpsat/pres);
}
