# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/* nwsua -- This lex subroutine converts National Weather Service
 * upper air soundings from teletype format to common data format.
 */
#include <math.h>
#define SCON 0.5144 /* knots to meters per second */
#define ACON 0.01745   /* degrees to radians conversion */
float uptab[54] =
{1010., 977., 943., 907., 875., 843., 807., 782., 752., 724., 696.,
 670., 643., 619., 595., 572., 550., 527., 506., 485., 465., 446.,
 428., 409., 393., 377., 360., 344., 329., 316., 302., 288., 275.,
 263., 250., 238., 227., 217., 206., 197., 188., 179., 171., 163.,
 155., 148., 141., 134., 128., 122., 116., 111., 106., 101.};
                    /* altitude to pressure conversion table */
char sname[10];     /* number of radiosonde station */
char tname[10];     /* time and date */
char ttemp[10];     /* temporary for time and date */
int linedate;       /* date from time stamp */
int savemonth = 0,saveyear = 0,lyear,lmonth,ldate;  /* temporaries */
int tdata;          /* flag to indicate temp and dewpt data in tdo */
float pres,temp,dewpt;  /* temporaries for thermo data */
int wstack;         /* number of winds left to analyze */
int wptr;           /* pointer to lsd wind alt */
int ndone;          /* wind temporary */
float speed,direct,elev,alt[5]; /* temps for wind data */
char line[5];       /* buffer */
# define init 2
# define ready 4
# define ready1 6
# define ready2 8
# define therm 10
# define t1 12
# define t2 14
# define wind 16
# define w1 18
# define w2 20
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
				{BEGIN init;}
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{getmy(yytext);}
break;
case 2:
{BEGIN ready1;}
break;
case 3:
			{BEGIN ready2;}
break;
case 4:
			{if (strlen(yytext) == 6) {
					   BEGIN ready;
					   strcpy(tname,yytext);
					 }
					 else BEGIN init;
					}
break;
case 5:
			{BEGIN therm; tdata = 0; bclear();}
break;
case 6:
			{BEGIN t1;}
break;
case 7:
			{if (strlen(yytext) == 5) {
					   BEGIN t2; strcpy(sname,yytext);
					 }
					 else BEGIN ready;
					}
break;
case 8:
		{BEGIN wind; wstack = 0;}
break;
case 9:
			{BEGIN w1;}
break;
case 10:
			{BEGIN w2;
					   if (strcmp(sname,yytext) != 0)
					        BEGIN ready;
					}
break;
case 11:
		{BEGIN ready;}
break;
case 12:
			{wbuff(); BEGIN ready;}
break;
case 13:
		{unput(yytext[0]);wbuff();BEGIN ready;}
break;
case 14:
			{tdo(yytext);}
break;
case 15:
			{wdo(yytext);}
break;
case 16:
				;
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

extern float *hour,*date,*month,*year;
extern float *index,*cpres,*ctemp,*cdewpt,*cuwind,*cvwind,*celev;
extern float *vbuff;
extern int nvbuff;
extern float bad;
extern int tmax,wmax;
static int loop;
static int tcount,wcount;
static char b1[15],b2[15],b3[15],b4[15],b5[15],b6[15];
static int nels;

/* get month and year from UNIX date line */
getmy(dateline)
char *dateline;
{
  nels = sscanf(dateline,"%s %s %s %s %s %s",b1,b2,b3,b4,b5,b6);
  if (nels == 6) {
    if (strncmp(b2,"Jan",3) == 0) savemonth = 1;
    else if (strncmp(b2,"Feb",3) == 0) savemonth = 2;
    else if (strncmp(b2,"Mar",3) == 0) savemonth = 3;
    else if (strncmp(b2,"Apr",3) == 0) savemonth = 4;
    else if (strncmp(b2,"May",3) == 0) savemonth = 5;
    else if (strncmp(b2,"Jun",3) == 0) savemonth = 6;
    else if (strncmp(b2,"Jul",3) == 0) savemonth = 7;
    else if (strncmp(b2,"Aug",3) == 0) savemonth = 8;
    else if (strncmp(b2,"Sep",3) == 0) savemonth = 9;
    else if (strncmp(b2,"Oct",3) == 0) savemonth = 10;
    else if (strncmp(b2,"Nov",3) == 0) savemonth = 11;
    else if (strncmp(b2,"Dec",3) == 0) savemonth = 12;
    else return;
    linedate = atoi(b3);
    saveyear = atoi(b6);
  }
}

#define TSLOP 10.0
#define PSLOP 3.0
/* interpret thermodynamic sounding number */
tdo(text)
char *text;
{
  char c;
  float twild,pwild,dup,ddown,dspan;
/* check data validity */
  if (strlen(text) != 5) {
    tdata = 0;
    return;
  }
  if (tdata == 0) {
/* pressure data */
    tdata = 1;
/* first two characters of pressure word must be equal */
    if (text[0] != text[1]) {
      tdata = 0;
      return;
    }
/* pressure must not be missing */
    if ((text[2] == '/')||(text[3] == '/')||(text[4] == '/')) {
      tdata = 0;
      return;
    }
    pres = atof(text + 2);
/* pressure represented mod 1000 */
    if (pres < 100.) pres += 1000.;
  }
/* temp and dewpoint data */
  else if (tdata == 1) {
    tdata = 0;
/* dewpoint depression first */
    c = text[3];
/* eliminate missing dewpoint */
    if ((c == '/') || (text[4] == '/')) dewpt = bad;
/* digit 4 >= 5 means whole number + 50 */
    else if ((c == '5')||(c == '6')||(c == '7')||(c == '8')||(c == '9'))
         dewpt = atof(text + 3) - 50.;
/* otherwise in tenths */
    else dewpt = atof(text + 3)/10.;
/* null terminate temperature part of string */
    text[3] = '\0';
/* absolute value of temperature */
    temp = atof(text)/10.;
    c = text[2];
/* temp negative if last digit odd */
    if ((c == '1')||(c == '3')||(c == '5')||(c == '7')||(c == '9')) {
      temp = -temp;
    }
/* construct dewpoint from temp and depression */
    if (dewpt < bad) dewpt = temp - dewpt;
    cpres[tcount] = pres;
    ctemp[tcount] = temp;
    cdewpt[tcount] = dewpt;
    if (tcount < tmax - 1) tcount++;
  }
/* do some error checking on temperature profiles */
/* first, pressures must be in decreasing order */
  for (loop = 1; loop < tcount; loop++) {
    if (cpres[loop] > cpres[loop - 1]) {
      tcount = tfix(tcount,loop);
    }
  }
/* check for wild temperatures and pressures */
  for (loop = 1; loop < tcount - 1; loop++) {
    dup = fabs(ctemp[loop + 1] - ctemp[loop]);
    ddown = fabs(ctemp[loop] - ctemp[loop - 1]);
    dspan = fabs(ctemp[loop + 1] - ctemp[loop - 1]);
    twild = dup + ddown - dspan - TSLOP;
    dup = fabs(cpres[loop + 1] - cpres[loop]);
    ddown = fabs(cpres[loop] - cpres[loop - 1]);
    dspan = fabs(cpres[loop + 1] - cpres[loop - 1]);
    pwild = dup + ddown - dspan - PSLOP;
/* if a wild value is found, eliminate that level */
    if ((twild > 0.) || (pwild > 0.)) {
      tcount = tfix(tcount,loop);
    }
  }
}

/* delete a line from thermodynamic data */
int tfix(tc,l)
int tc,l;
{
  int i;
  for (i = l; i < tc - 1; i++ ) {
    cpres[i] = cpres[i + 1];
    ctemp[i] = ctemp[i + 1];
    cdewpt[i] = cdewpt[i + 1];
  }
  cpres[tc - 1] = ctemp[tc - 1] = cdewpt[tc - 1] = bad;
  return(tc - 1);
}

/* interpret wind sounding number */
wdo(text)
char *text;
{
/* check for bad data */
  if (strlen(text) != 5) return;
  if (text[0] == '9') {
/* we have an altitude designator */
    if (wstack != 0) {
      wstack = 0;
    }
    wptr = 2;
    while (wptr < 5) {
      line[0] = text[1];
      if ((line[1] = text[wptr]) == '/') break;
      line[2] = '\0';
      alt[wstack] = atof(line);
      wptr++;
      wstack++;
    }
    ndone = 0;
  }
  else {
/* we have some winds */
    if (wstack <= 0) {
      return;
    }
    elev = alt[ndone];
    if (text[0] != '/') {
      speed = atof(text + 3);
      text[3] = '\0';
      direct = atof(text);
    }
    else speed = direct = bad;
    ndone++;
    wstack--;
/* get east and north wind components */
    cuwind[wcount] = -speed*sin(direct*ACON)*SCON;
    cvwind[wcount] = -speed*cos(direct*ACON)*SCON;
/* turn heights back into pressures */
    if (elev <= 0.) celev[wcount] = cpres[0];
    else if (elev < 53.4) {
      celev[wcount] = uptab[(int)(elev + .5)];
    }
    if (wcount < wmax - 1) wcount++;
  }
}

/* begin cdf buffer */
bclear()
{
  tcount = wcount = 0;
  for (loop = 0; loop < wmax; loop++) {
    cuwind[loop] = cvwind[loop] = celev[loop] = bad;
  }
  for (loop = 0; loop < tmax; loop++) {
    cpres[loop] = ctemp[loop] = cdewpt[loop] = bad;
  }
}

/* write cdf buffer */
wbuff()
{
  strcpy(ttemp,tname);
  ttemp[4] = '\0';
  *hour = atof(ttemp + 2);
  ttemp[2] = '\0';
  *date = atof(ttemp);
  *index = atof(sname);
  lyear = saveyear;
  lmonth = savemonth;
  if ((lmonth < 1) || (lmonth > 12)) {
    *year = 0.;
    *month = 0.;
    putslice(stdout,nvbuff,vbuff);
    return;
  }
  ldate = *date + .5;
/* date stamp new month, sounding old month */
  if (ldate - linedate > 15) {
    lmonth--;
    if (lmonth == 0) {
      lmonth = 12;
      lyear--;
    }
  }
/* date stamp old month, sounding new month */
  if (ldate - linedate < -15) {
    lmonth++;
    if (lmonth == 13) {
      lmonth = 1;
      lyear++;
    }
  }
  *month = lmonth;
  *year = lyear;
  putslice(stdout,nvbuff,vbuff);
}
int yyvstop[] = {
0,

16,
0,

16,
0,

16,
0,

16,
0,

16,
0,

3,
16,
0,

4,
16,
0,

6,
16,
0,

11,
16,
0,

7,
16,
0,

14,
16,
0,

16,
0,

9,
16,
0,

12,
16,
0,

13,
16,
0,

10,
16,
0,

15,
16,
0,

3,
0,

4,
0,

6,
0,

7,
0,

14,
0,

9,
0,

10,
0,

15,
0,

2,
0,

8,
0,

5,
0,

2,
0,

2,
0,

1,
0,
0};
# define YYTYPE char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,23,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,23,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,23,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	52,56,	0,0,	
1,23,	1,23,	9,29,	10,29,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,23,	
11,30,	11,30,	0,0,	12,30,	
12,30,	0,0,	1,23,	3,24,	
4,24,	7,28,	5,24,	8,28,	
13,32,	13,32,	11,31,	0,0,	
6,24,	12,31,	14,32,	14,32,	
15,33,	15,33,	42,54,	16,33,	
16,33,	5,26,	13,31,	3,25,	
4,25,	5,27,	5,25,	6,26,	
14,31,	26,42,	15,31,	6,27,	
6,25,	16,31,	1,23,	27,43,	
17,35,	17,35,	34,42,	18,35,	
18,35,	19,38,	19,38,	43,55,	
20,38,	20,38,	21,39,	21,39,	
54,58,	15,34,	17,36,	55,59,	
16,34,	18,36,	17,37,	19,36,	
0,0,	18,37,	20,36,	19,37,	
21,36,	0,0,	20,37,	0,0,	
21,37,	22,39,	22,39,	29,45,	
29,45,	29,45,	29,45,	29,45,	
29,45,	29,45,	29,45,	29,45,	
29,45,	0,0,	0,0,	22,36,	
0,0,	0,0,	0,0,	22,37,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	24,40,	24,40,	
24,40,	24,40,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
25,41,	25,41,	25,41,	25,41,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
25,40,	25,40,	25,40,	25,40,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	28,44,	28,44,	
28,44,	28,44,	30,46,	30,46,	
30,46,	30,46,	30,46,	30,46,	
30,46,	30,46,	30,46,	30,46,	
30,46,	32,47,	32,47,	32,47,	
32,47,	32,47,	32,47,	32,47,	
32,47,	32,47,	32,47,	32,47,	
33,48,	33,48,	33,48,	33,48,	
33,48,	33,48,	33,48,	33,48,	
33,48,	33,48,	33,48,	35,49,	
35,49,	35,49,	35,49,	35,49,	
35,49,	35,49,	35,49,	35,49,	
35,49,	35,49,	38,50,	38,50,	
38,50,	38,50,	38,50,	38,50,	
38,50,	38,50,	38,50,	38,50,	
38,50,	39,51,	39,51,	39,51,	
39,51,	39,51,	39,51,	39,51,	
39,51,	39,51,	39,51,	39,51,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	40,52,	40,52,	
40,52,	40,52,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
41,53,	41,53,	41,53,	41,53,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	53,57,	53,57,	
53,57,	53,57,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
56,60,	56,60,	56,60,	56,60,	
57,61,	57,61,	57,61,	57,61,	
57,61,	57,61,	57,61,	57,61,	
57,61,	57,61,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
60,62,	60,62,	60,62,	60,62,	
61,63,	61,63,	61,63,	61,63,	
61,63,	61,63,	61,63,	61,63,	
61,63,	61,63,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
62,64,	62,64,	62,64,	62,64,	
64,65,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	64,65,	
64,65,	64,65,	64,65,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+0,	yysvec+1,	0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+-3,	yysvec+1,	0,	
yycrank+-5,	yysvec+1,	0,	
yycrank+-11,	yysvec+1,	0,	
yycrank+-4,	yysvec+1,	0,	
yycrank+-6,	yysvec+1,	0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+-3,	yysvec+1,	0,	
yycrank+-13,	yysvec+1,	0,	
yycrank+-16,	yysvec+1,	0,	
yycrank+-25,	yysvec+1,	0,	
yycrank+-31,	yysvec+1,	0,	
yycrank+-33,	yysvec+1,	0,	
yycrank+-36,	yysvec+1,	0,	
yycrank+-53,	yysvec+1,	0,	
yycrank+-56,	yysvec+1,	0,	
yycrank+-58,	yysvec+1,	0,	
yycrank+-61,	yysvec+1,	0,	
yycrank+-63,	yysvec+1,	0,	
yycrank+-82,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+51,	0,		yyvstop+3,
yycrank+109,	0,		yyvstop+5,
yycrank+13,	yysvec+24,	yyvstop+7,
yycrank+15,	yysvec+24,	yyvstop+9,
yycrank+167,	0,		yyvstop+11,
yycrank+83,	0,		yyvstop+14,
yycrank+211,	0,		yyvstop+17,
yycrank+0,	0,		yyvstop+20,
yycrank+222,	0,		yyvstop+23,
yycrank+233,	0,		yyvstop+26,
yycrank+22,	0,		yyvstop+29,
yycrank+244,	0,		yyvstop+31,
yycrank+0,	0,		yyvstop+34,
yycrank+0,	0,		yyvstop+37,
yycrank+255,	0,		yyvstop+40,
yycrank+266,	0,		yyvstop+43,
yycrank+227,	0,		0,	
yycrank+285,	0,		0,	
yycrank+16,	0,		0,	
yycrank+41,	0,		0,	
yycrank+0,	yysvec+28,	yyvstop+46,
yycrank+0,	yysvec+29,	yyvstop+48,
yycrank+0,	yysvec+30,	yyvstop+50,
yycrank+0,	yysvec+32,	yyvstop+52,
yycrank+0,	yysvec+33,	yyvstop+54,
yycrank+0,	yysvec+35,	yyvstop+56,
yycrank+0,	yysvec+38,	yyvstop+58,
yycrank+0,	yysvec+39,	yyvstop+60,
yycrank+14,	0,		0,	
yycrank+311,	0,		0,	
yycrank+46,	0,		0,	
yycrank+49,	0,		0,	
yycrank+337,	0,		0,	
yycrank+380,	0,		yyvstop+62,
yycrank+0,	0,		yyvstop+64,
yycrank+0,	0,		yyvstop+66,
yycrank+341,	0,		0,	
yycrank+416,	0,		yyvstop+68,
yycrank+377,	0,		0,	
yycrank+0,	0,		yyvstop+70,
yycrank+468,	0,		0,	
yycrank+0,	yysvec+64,	yyvstop+72,
0,	0,	0};
struct yywork *yytop = yycrank+590;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
040 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,'/' ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,':' ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
01  ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	}
yyunput(c)
   int c; {
	unput(c);
	}
