%{
#define MAX 10000
#define TEXTMAX 1400
long nrecords[8] = {0,0,0,0,0,0,0,0},rtype = 0;
char td[10],id[10],th[10],hd[10],unixdate[82] = "undefined";
char timedate[8][MAX][8],thing[8][MAX][7],ident[8][MAX][7],
  textbuff[8][MAX][TEXTMAX];
char *headers[8] = {"TTAA","PPAA","TTBB","PPBB","TTCC","PPCC","TTDD","PPDD"};
%}
%Start udate header idt data ttaa ttbb ttcc ttdd ppaa ppbb ppcc ppdd nothing
%%
			{BEGIN nothing; /* start sane */}
"\r"			{/* ignore carriage returns */}
<nothing>[A-Z][a-z][a-z][ ][A-Z][a-z][a-z][ A-Za-z0-9:]+	{BEGIN udate;
				if (strncmp(unixdate,yytext,80) != 0) {
					printf("%s\n",yytext);
					doflush();
				}
				/* print UNIX date if new and flush */}
<udate>"\n"		{BEGIN nothing;}
<nothing>"U"[A-Z][A-Z][A-Z][0-9][0-9]?" "[ A-Z]+	{BEGIN header;
				 /* time-date */}
<header>[0-9][0-9][0-9][0-9][0-9][0-9]	{strncpy(td,yytext,8);
				/* grab the time-date */}
<header>.		{/* ignore the rest of the header */}
<header>"\n"		{BEGIN nothing;}
<nothing>"TT"..[ 0-9/]+"NIL="	{/* a null record */}
<nothing>"PP"..[ 0-9/]+"NIL="	{/* a null record */}
<nothing>"TT"..[ 0-9/]+"XMTD="	{/* a null record */}
<nothing>"PP"..[ 0-9/]+"XMTD="	{/* a null record */}
<nothing>"TTAA"		{BEGIN ttaa; rtype = 0;}
<nothing>"TTBB"		{BEGIN ttbb; rtype = 2;}
<nothing>"TTCC"		{BEGIN ttcc; rtype = 4;}
<nothing>"TTDD"		{BEGIN ttdd; rtype = 6;}
<nothing>"PPAA"		{BEGIN ppaa; rtype = 1;}
<nothing>"PPBB"		{BEGIN ppbb; rtype = 3;}
<nothing>"PPCC"		{BEGIN ppcc; rtype = 5;}
<nothing>"PPDD"		{BEGIN ppdd; rtype = 7;}
<ttaa,ttbb,ttcc,ttdd,ppaa,ppbb,ppcc,ppdd>[0-9][0-9][0-9][0-9][0-9]	{
				BEGIN idt; strncpy(th,yytext,7);
				/* this grabs the thing in front of id */}
<idt>[0-9][0-9][0-9][0-9][0-9]	{BEGIN data; strncpy(id,yytext,7);
				/* this grabs the id */}
<data>[ 0-9/\n\r]+	{addtolist(yytext);
				/* this captures the data */}
<idt,data>"="|"\003"	{BEGIN nothing;}
"\n"			{/* ignore newlines */}
.			{/* ignore everything else */}
%%

/* this routine adds a record to the list to be sorted later */
addtolist(text)
char *text;
{

/* quit if too may records */
  if (nrecords[rtype] >= MAX) {
    fprintf(stderr,"nwsuaorder: too many type %d records!\n",rtype);
    exit(1);
  }

/* otherwise add to lists */
  strncpy(timedate[rtype][nrecords[rtype]],td,7);
  strncpy(thing[rtype][nrecords[rtype]],th,6);
  strncpy(ident[rtype][nrecords[rtype]],id,6);
  strncpy(textbuff[rtype][nrecords[rtype]],text,TEXTMAX);

/* print out stuff for diagnostics */
/*
  fprintf(stderr,"header type: %d\n",rtype);
  fprintf(stderr,"record: %d\n",nrecords[rtype]);
  fprintf(stderr,"timedate: %s\n",timedate[rtype][nrecords[rtype]]);
  fprintf(stderr,"the thing: %s\n",thing[rtype][nrecords[rtype]]);
  fprintf(stderr,"ident: %s\n",ident[rtype][nrecords[rtype]]);
  fprintf(stderr,"data: %s\n\n",textbuff[rtype][nrecords[rtype]]);
*/

/* increment record number */
  nrecords[rtype]++;
}

/* flush on end */
yywrap()
{
  doflush();
  return(1);
}

/* the flush routine -- this is done the dumb way because I am too
 * lazy to do an efficient sort
 */
doflush()
{
  long i,j,k;

/* loop over TT type */
  for (i = 0; i < 8; i += 2) {

/* loop over the TT instances */
    for (j = 0; j < nrecords[i]; j++) {

/* loop over the PP instances */
      for (k = 0; k < nrecords[i + 1]; k++) {

/* compare idents */
	if (strcmp(ident[i][j],ident[i + 1][k]) == 0) {

/* compare the time and date */
	  if (strcmp(timedate[i][j],timedate[i + 1][k]) == 0) {

/* looks like we have a match -- write the stuff */
	    printf("USUS99 KXXX %s\n",timedate[i][j]);
	    printf("%s %s %s %s=\n",headers[i],thing[i][j],
		   ident[i][j],textbuff[i][j]);
	    printf("%s %s %s %s=\n\n",headers[i + 1],thing[i + 1][k],
		   ident[i + 1][k],textbuff[i + 1][k]);

/* wipe so we don't write again on another match */
            strcpy(ident[i][j],"");
            strcpy(timedate[i][j],"");
	  }
	}

/* end loops */
      }
    }
  }

/* reset the counters */
  for (i = 0; i < 8; i++) {
    nrecords[i] = 0;
  }
}
