%{
FILE *ofile;
#define SOUND "sound"
#define SURF "surf"
#define MXSURF "mxsurf"
#define RADAR "radar"
#define FCAST "fcast"
#define SUMM "summ"
#define REPS "reports"
#define TRAV "trav"
#define WATCH "watches"
#define SEV "severe"
#define TATL "tropatlantic"
#define FECHO if (fprintf(ofile,"%s",yytext) == EOF) cry();
%}
%Start turnon turnoff surfobs surfon mxsobs mxson
%e 2000
%p 4000
%n 1000
%%
				{BEGIN turnoff;
				   /* start out sane */}
"\r"				{/* ignore carriage returns */;}
<turnon>"\003"			{BEGIN turnoff; FECHO;
				   fclose(ofile);
				   /* turn off on ETX */}
<surfobs>"\003"			{BEGIN turnoff;
				   fclose(ofile);
				   /* turn off on ETX */}
<mxsobs>"\003"			{BEGIN turnoff;
				   fclose(ofile);
				   /* turn off on ETX */}
<turnoff>^"U"[ACDEFGHIJKLMNOPQRSTUVWYZ]"US"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* US soundings */}
<turnoff>^"UJBE"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Bermuda soundings */}
<turnoff>^"UJGM"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Guam soundings */}
<turnoff>^"UJ"		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Hawaii soundings (everything) */}
<turnoff>^"UJPM"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Panama soundings */}
<turnoff>^"UMMX"[12]" MXBA"	{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Mexican soundings */}
<turnoff>^"U"[A-Z]"CN"[0-9]+	{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Canadian soundings */}
<turnoff>^"UMCA"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Caribbean soundings */}
<turnoff>^"UMCU"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Cuban soundings */}
<turnoff>^"UK"[BC]"A"[0-9]+		{BEGIN turnon;
				   if ((ofile = fopen(SOUND,"a")) == NULL) di();
				   else FECHO; /* Bahamas and Trinidad */}
<turnoff>^"SAUS"			{BEGIN surfobs;
				   if ((ofile = fopen(SURF,"a")) == NULL) di();
				   /* US surface hourly reports */}
<surfobs>"KABQ "		{parityrep(); FECHO; BEGIN surfon;}
<surfobs>"KRUI "		{FECHO; BEGIN surfon;}
<surfobs>"KSAF "		{FECHO; BEGIN surfon;}
<surfobs>"KDMN "		{FECHO; BEGIN surfon;}
<surfobs>"KFMN "		{FECHO; BEGIN surfon;}
<surfobs>"KSVC "		{FECHO; BEGIN surfon;}
<surfobs>"KCNM "		{FECHO; BEGIN surfon;}
<surfobs>"KROW "		{FECHO; BEGIN surfon;}
<surfobs>"KTCC "		{FECHO; BEGIN surfon;}
<surfobs>"KTCS "		{FECHO; BEGIN surfon;}
<surfobs>"KGUP "		{FECHO; BEGIN surfon;}
<surfobs>"KLVS "		{FECHO; BEGIN surfon;}
<surfobs>"KHOB "		{FECHO; BEGIN surfon;}
<surfobs>"KRTN "		{FECHO; BEGIN surfon;}
<surfobs>"KCAO "		{FECHO; BEGIN surfon;}
<surfobs>"KCVS "		{FECHO; BEGIN surfon;}
<surfobs>"KONM "		{FECHO; BEGIN surfon;}
<surfobs>"KLRU "		{FECHO; BEGIN surfon;}
<surfobs>"KZUN "		{FECHO; BEGIN surfon;}
<surfobs>"KALM "		{FECHO; BEGIN surfon;}
<surfobs>"KQ37 "		{FECHO; BEGIN surfon;}
<surfobs>"KE33 "		{FECHO; BEGIN surfon;}
<surfobs>"KP70 "		{FECHO; BEGIN surfon;}
<surfobs>"KCVN "		{FECHO; BEGIN surfon;}
<surfobs>"KCUS "		{FECHO; BEGIN surfon;}
<surfobs>"K4CR "		{FECHO; BEGIN surfon;}
<surfobs>"K4SL "		{FECHO; BEGIN surfon;}
<surfobs>"KFSU "		{FECHO; BEGIN surfon;}
<surfobs>"KGNT "		{FECHO; BEGIN surfon;}
<surfobs>"KHMN "		{FECHO; BEGIN surfon;}
<surfobs>"KQ03 "		{FECHO; BEGIN surfon;}
<surfobs>"K4MY "		{FECHO; BEGIN surfon;}
<surfobs>"KE23 "		{FECHO; BEGIN surfon;}
<surfobs>"KDUG "		{FECHO; BEGIN surfon;}
<surfobs>"KPHX "		{FECHO; BEGIN surfon;}
<surfobs>"KTUS "		{FECHO; BEGIN surfon;}
<surfobs>"KFLG "		{FECHO; BEGIN surfon;}
<surfobs>"KINW "		{FECHO; BEGIN surfon;}
<surfobs>"KSOW "		{FECHO; BEGIN surfon;}
<surfobs>"KPRC "		{FECHO; BEGIN surfon;}
<surfobs>"KPGA "		{FECHO; BEGIN surfon;}
<surfobs>"KGBN "		{FECHO; BEGIN surfon;}
<surfobs>"KYUM "		{FECHO; BEGIN surfon;}
<surfobs>"KOAB "		{FECHO; BEGIN surfon;}
<surfobs>"KBCE "		{FECHO; BEGIN surfon;}
<surfobs>"KSLC "		{FECHO; BEGIN surfon;}
<surfobs>"KLAS "		{FECHO; BEGIN surfon;}
<surfobs>"KTPH "		{FECHO; BEGIN surfon;}
<surfobs>"KELY "		{FECHO; BEGIN surfon;}
<surfobs>"KALS "		{FECHO; BEGIN surfon;}
<surfobs>"KPUB "		{FECHO; BEGIN surfon;}
<surfobs>"KCOS "		{FECHO; BEGIN surfon;}
<surfobs>"KLAA "		{FECHO; BEGIN surfon;}
<surfobs>"KTAD "		{FECHO; BEGIN surfon;}
<surfobs>"KDEN "		{FECHO; BEGIN surfon;}
<surfobs>"KDIA "		{FECHO; BEGIN surfon;}
<surfobs>"KGJT "		{FECHO; BEGIN surfon;}
<surfobs>"KDRO "		{FECHO; BEGIN surfon;}
<surfobs>"KCEZ "		{FECHO; BEGIN surfon;}
<surfobs>"KELP "		{FECHO; BEGIN surfon;}
<surfobs>"KDHT "		{FECHO; BEGIN surfon;}
<surfobs>"KAMA "		{FECHO; BEGIN surfon;}
<surfobs>"KLBB "		{FECHO; BEGIN surfon;}
<surfobs>"KMAF "		{FECHO; BEGIN surfon;}
<surfobs>"KGDP "		{FECHO; BEGIN surfon;}
<surfobs>"KSAN "		{FECHO; BEGIN surfon;}
<surfobs>"KLAX "		{FECHO; BEGIN surfon;}
<surfobs>"KSBA "		{FECHO; BEGIN surfon;}
<surfobs>"KSFO "		{FECHO; BEGIN surfon;}
<surfobs>"KRNO "		{FECHO; BEGIN surfon;}
<surfobs>"KABI "		{FECHO; BEGIN surfon;}
<surfobs>"KSPS "		{FECHO; BEGIN surfon;}
<surfobs>"KHBR "		{FECHO; BEGIN surfon;}
<surfobs>"KOKC "		{FECHO; BEGIN surfon;}
<surfobs>"KADM "		{FECHO; BEGIN surfon;}
<surfobs>"KDFW "		{FECHO; BEGIN surfon;}
<surfobs>"KMLC "		{FECHO; BEGIN surfon;}
<surfobs>"KDDC "		{FECHO; BEGIN surfon;}
<surfobs>"KICT "		{FECHO; BEGIN surfon;}
<surfobs>"KTUL "		{FECHO; BEGIN surfon;}
<surfobs>"KTOP "		{FECHO; BEGIN surfon;}
<surfobs>"KRKS "		{FECHO; BEGIN surfon;}
<surfobs>"KRWL "		{FECHO; BEGIN surfon;}
<surfobs>"KCHE "		{FECHO; BEGIN surfon;}
<surfobs>"KLAR "		{FECHO; BEGIN surfon;}
<surfobs>"KCYS "		{FECHO; BEGIN surfon;}
<surfobs>"KLBF "		{FECHO; BEGIN surfon;}
<surfobs>"KGRI "		{FECHO; BEGIN surfon;}
<surfobs>"KVCT "		{FECHO; BEGIN surfon;}
<surfobs>"KACT "		{FECHO; BEGIN surfon;}
<surfobs>"KCLL "		{FECHO; BEGIN surfon;}
<surfobs>"KBRO "		{FECHO; BEGIN surfon;}
<surfobs>"KLRD "		{FECHO; BEGIN surfon;}
<surfobs>"KMOV "		{FECHO; BEGIN surfon;}
<surfobs>"KSAT "		{FECHO; BEGIN surfon;}
<surfobs>"KDLF "		{FECHO; BEGIN surfon;}
<surfobs>"KSJT "		{FECHO; BEGIN surfon;}
<surfobs>"KSEA "		{FECHO; BEGIN surfon;}
<surfobs>"KLFT "		{FECHO; BEGIN surfon;}
<surfobs>"KLCH "		{FECHO; BEGIN surfon;}
<surfobs>"KBPT "		{FECHO; BEGIN surfon;}
<surfobs>"KIAH "		{FECHO; BEGIN surfon;}
<surfobs>"KHOU "		{FECHO; BEGIN surfon;}
<surfobs>"KGAL "		{FECHO; BEGIN surfon;}
<surfon>.			{FECHO;}
<surfon>"\n"			{FECHO; BEGIN surfobs;}
<turnoff>^"SAMX"		{BEGIN mxsobs;
				   if ((ofile = fopen(MXSURF,"a")) == NULL) di();
				   /* Mexican surface hourly reports */}
<mxsobs>"CJS"			{FECHO; BEGIN mxson;}
<mxsobs>"MXL"			{FECHO; BEGIN mxson;}
<mxsobs>"MEX"			{FECHO; BEGIN mxson;}
<mxsobs>"MTY"			{FECHO; BEGIN mxson;}
<mxsobs>"TRC"			{FECHO; BEGIN mxson;}
<mxsobs>"DGO"			{FECHO; BEGIN mxson;}
<mxsobs>"CUL"			{FECHO; BEGIN mxson;}
<mxsobs>"LMM"			{FECHO; BEGIN mxson;}
<mxsobs>"CUU"			{FECHO; BEGIN mxson;}
<mxsobs>"LAP"			{FECHO; BEGIN mxson;}
<mxsobs>"SJD"			{FECHO; BEGIN mxson;}
<mxsobs>"LTO"			{FECHO; BEGIN mxson;}
<mxsobs>"PPE"			{FECHO; BEGIN mxson;}
<mxsobs>"HMO"			{FECHO; BEGIN mxson;}
<mxsobs>"GYM"			{FECHO; BEGIN mxson;}
<mxsobs>"MOV"			{FECHO; BEGIN mxson;}
<mxson>.			{FECHO;}
<mxson>"\n"			{FECHO; BEGIN mxsobs;}
<turnoff>^"FPUS1 KABQ"		{BEGIN turnon;
				   if ((ofile = fopen(FCAST,"w")) == NULL) di();
				   else FECHO; /* NM state forecast */}
<turnoff>^"FPUS10 KWBC"		{BEGIN turnon;
				   if ((ofile = fopen(TRAV,"w")) == NULL) di();
				   else FECHO; /* National travel forecast */}
<turnoff>^"ABUS30 KABQ"		{BEGIN turnon;
				   if ((ofile = fopen(SUMM,"w")) == NULL) di();
				   else FECHO; /* NM weather summary */}
<turnoff>^"ABUS21 KABQ"		{BEGIN turnon;
				   if ((ofile = fopen(REPS,"w")) == NULL) di();
				   else FECHO; /* NM station reports */}
<turnoff>^"SDXX1 KZAB"		{BEGIN turnon;
				   if ((ofile = fopen(RADAR,"w")) == NULL) di();
				   else FECHO; /* NM weather radar report */}
<turnoff>^"WTNT"		{BEGIN turnon;
				   if ((ofile = fopen(WATCH,"a")) == NULL) di();
				   else FECHO; /*  Hurricane stuff */}
<turnoff>^"WTPZ"		{BEGIN turnon;
				   if ((ofile = fopen(WATCH,"a")) == NULL) di();
				   else FECHO; /*  Hurricane stuff */}
<turnoff>^"ABNT20 KMIA"		{BEGIN turnon;
				   if ((ofile = fopen(TATL,"w")) == NULL) di();
				   else FECHO; /*  Tropical atlantic */}
<turnoff>^"WWUS3"[0-9]" KABQ"	{BEGIN turnon;
				   if ((ofile = fopen(SEV,"w")) == NULL) di();
				   else FECHO; /*  Local warnings & watches */}
<turnon>.|"\n"			{FECHO;}
<turnoff,surfobs,mxsobs>.|"\n"	{/* ignore stuff not needed */;}
%%
#define MAX 101
#define PARITY 1
char cin,cbuff[MAX];
int cptr = 0;
long numoddpar = 0,numevenpar = 0;

#include <errno.h>
#include <sys/types.h>
#undef input
#undef unput
char input()
/* modified lex input routine that eliminates nulls */
{
  int readret;
  if (cptr <= 0) {
    if ((readret = read(0,&cin,1)) <= 0) {
      return(0);
    }
#if PARITY
/* optional parity reporting */
    if (parity(cin)) numoddpar++;
    else numevenpar++;
#endif
    cin = cin & 0177;
  }
  else cin = cbuff[--cptr];
  if (cin == 0) cin = '\r';
  return(cin);
}

#if PARITY
parity(c)
/* parity computer -- returns 1 for odd parity, 0 for even */
char c;
{
  int sum,i;
  sum = 0;
  for (i = 0; i < 8; i++) {
    sum = sum ^ c;
    c = c >> 1;
  }
  sum = sum & 01;
  return(sum);
}
#endif

parityrep()
{
#if PARITY
  fprintf(ofile,"parity report: odd = %ld, even = %ld\n",numoddpar,numevenpar);
  numoddpar = numevenpar = 0;
#endif
}

unput(c)
/* matching unput routine */
char c;
{
  cbuff[cptr++] = c;
}

extern int errno;
di()
/* response to error on open */
{
  fclose(ofile);
  BEGIN turnoff;
}

cry()
/* response to error on write */
{
  fclose(ofile);
  BEGIN turnoff;
}
