// A demonstration program for portable graphics under rlab.
pgdemo = function()
{

// set things up
  pgopen();

// make some superimposed 2-D plots
  pgclear();
  pgwindow(1, 1, 1, 14, 9);
  pgaxes(1, 0, 20, 11, "x-axis", 0, 15, 16, "y-axis");
  x = [0:20];
  y = [0:15]';
  a = y*x;
  b = sin(a/30.);
  pgconto(1, .2, 5, b, x, y);
  pgfill(1, -.2, .2, 14, b, x, y);
  pggrid(1, 3, 3, b, x, y);
  pglabel(1, 2, 14, "Contour, fill, and grid plots");
  pgpause();

// make a 3-D plot
  pgclear();
  pgwindow(1, 0, 0, 7.5, 7.5);
  pgpview(1, 5., 5., 5., 0., 0., 0., 3.);
  for (j in -2:2:0.05) {
    xx = [j, j];
    yy = [-2, 2];
    zz = [.5*sin(2.5*j), -.5*sin(2.5*j)];
    pgpline(1, 9, xx, yy, zz);
  }
  pgplabel(1, 0., 0., 1., "Funny 3-D plot");

// make a surface perspective plot on the same page
  pgwindow(2, 7.5, 2.5, 15, 10);
  pgpview(2, 40, -40, 20, 10, 7.5, 0,3);
  pgpaxes(2, 0, 20, 1 , "x-axis", 0, 15, 1, "y-axis", -1, 1, 2, "z-axis");
  pgpsurface(2, 13, b, x, y);
  pgplabel(2, 0., 0., 4.,"Surface perspective plot");
  pgpause();

// make some ordinary plots
  pgclear();
  pgwindow(1, 0, 0, 7.5, 7.5);
  pgaxes(1, 0, 20, 5, "x", -1, 1, 5, "sin(x/3)");
  s = sin(x/3);
  c = cos(x/3);
  pgline(1, 13, x, s);
  for (i in 1:21) {
    pgmark(1, 5, x[i], s[i], .5);
  }
  pglabel(1, 1, 0.8, "Plot of sine function");
  pgwindow(2, 7.5, 0, 15, 7.5);
  pgaxes(2, 0, 20, 5, "x", -1, 1, 5, "cos(x/3)");
  pgline(2, 12, x, c);
  for (i in 1:21) {
    pgmark(2, 8, x[i], c[i], .5);
  }
  pglabel(2, 1, 0.8, "Plot of cosine function");
  pgpause();

// make a vector plot
  pgclear();
  pgwindow(1, 0, 0, 10, 10);
  pgaxes(1, -10, 10, 11, "xxx", -10, 10, 11, "yyy");
  xx = ones(21,1)*[-10:10];
  yy = -[-10:10]'*ones(1,21);
  pgvector(1, .1, .1, yy, xx, [-10:10], [-10:10]');
  pglabel(1, -8, 8, "Vector plot");
  pgpause();

// finish up
  pgclose();
}
