/* creates a plain binary byte image 444x888 from a COARE postscript
image generated by gri */

#include <stdio.h>

char line[79];
int pix;
char image[444*888];
int i,j;

FILE *input, *output;

main(argc,argv)
int argc;
char* argv[];
{
if(argc!=3)
	{
	fprintf(stderr,"Usage:  makebin postscript_file binary_file\n");
	exit(99);
	}

input=fopen(argv[1],"r");
if(input==NULL)
	{
	perror(argv[1]);
	exit(98);
	}

output=fopen(argv[2],"w");
if(output==NULL)
	{
	perror(argv[2]);
	exit(97);
	}

fprintf(stderr,"Converting postscript image  %s  to binary image  %s\n",argv[1],argv[2]);

/* position at the start of the hexadecimal image */

while (!feof(input))
	{
	fscanf(input,"%6s",line);
	if (line[0]!='%')
		{
		while(fgetc(input)!='\n');
		continue;
		}
	else 
		{
		if(strcmp(line,"%BEGIN"))
			continue;
		else
			{
			while(fgetc(input)!='\n');
			while(fgetc(input)!='\n');
			break;
			}
		}
	}

if(feof(input))
	{
	fprintf(stderr,"Not a postcript image file\n");
	exit(96);
	}

/* read the hexadecimal image data: 10109 lines of 78 characters
or 39 pixels, followed by one line of 42 characters or 21 pixels */

for(i=0;i<10109;i++)
	{
	fscanf(input,"%78s",line);
	for(j=0;j<39;j++)
		{
		sscanf(line+2*j,"%2x",&pix);
		image[i*39+j]=(unsigned char)pix;
		}
	}

i=10109;

fscanf(input,"%42s",line);
for(j=0;j<21;j++)
	{
	sscanf(line+2*j,"%2x",&pix);
	image[i*39+j]=(unsigned char)pix;
	}
	
/* write binary image */

fwrite(image,1,444*888,output);

fclose(input);
fclose(output);

fprintf(stderr,"Created binary file %s\n",argv[2]);

}
