#include <stdio.h>
#include <math.h>
#include <string.h>

#define SX 888
#define SY 444
#define WINX 1024
#define WINY 640
#define MAXIMAGES 50
#define OX 112 
#define OY 130
#define NUMCOLORS 7

int ncolors;                    /* number of colors */
int colornumber;                /* color choice for polyfill */
long cvals[256];                /* pixel values */
int image_depth;                /* depth of image supported by display */


int numcolors = NUMCOLORS;
char monthname[12][4] = {
  "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep",
  "Oct","Nov","Dec"};
unsigned char color[WINY][WINX];
unsigned char mono[WINY][WINX/8];
unsigned char colortable[256];
unsigned char inputline[SX];
int BWthreshtemp[4] = {
  25,0,-20,-65};
int threshtemp[NUMCOLORS - 1] = {
  25,10,0,-20,-38,-65};
unsigned char colorkey[NUMCOLORS] = {
  24,25,26,27,28,29,31};
int xloc[4],yloc[4];
int i,j,k;
FILE *fp;
int lon1=135;
int lon2=175;
int lat1=-10;
int lat2=10;
float pausetime=1;
unsigned seconds,useconds;
int grid=3;
char *filename[MAXIMAGES];
int numfiles = 0;
int ch;
int BW = 0;
int dir = 1;
int olddir = 1;
int mousex,mousey,mousebutton;
char dirname[3][10] = {
  "REVERSE","PAUSE  ","       "};
int overlayflag = 0;
char overlayfilename[] = "/usr/local/lib/viewsat/coast";

/*
void keysquare(int image,int x,int y,int c,int t1,int t2);
void tempbar(int image,int y);
void tickmarks(int image);
void drawkey(int image,int x,int y);
void drawdate(int image,int x,int y);
void dither(unsigned char c[5]);
void tempbarBW(unsigned char c[5],int y);
*/

main(argc,argv)
int argc;
char *argv[];
{

  for(i = 1;i < argc;i++)
  {
    if(argv[i][0] != '-')
    {
      filename[numfiles++] = argv[i];
    }
    else if(argv[i][1] == 'o')
      overlayflag = 1;
    else if(argv[i][1] == 'p')
      sscanf(argv[i],"-p%f",&pausetime);
    else if(argv[i][1] == 'g')
    {
      if(argv[i][2] == '0')
        grid = 2;
      else if(argv[i][2] == '1')
        grid = 5;
      else if(argv[i][2] == '2')
        grid = 4;
      else if(argv[i][2] == '5')
        grid = 3;
      else if(argv[i][2] == 'e')
        grid = 1;
      else if(argv[i][2] == 'n')
        grid = 0;
      else
      {
        fprintf(stderr,"%s: Invalid grid argument %s\n",argv[0],argv[i]);
        exit(1);
      }
    }
    else
    {
      fprintf(stderr,"%s: Invalid argument %s\n",argv[0],argv[i]);
      exit(1);
    }
  }


  if(numfiles == 0 || numfiles > MAXIMAGES)
  {
    fprintf(stderr,"%s: Invalid number of arguments\n",argv[0]);
    if(numfiles > MAXIMAGES)
      fprintf(stderr,"%s: No more than %d files allowed\n",argv[0],MAXIMAGES);
    fprintf(stderr,"%s: Usage:\n",argv[0]);
    fprintf(stderr,"%s:   %s [-px.x] [-gn] [-oFile] image1 [image2 [image3 [...]]]\n",argv[0],argv[0]);
    fprintf(stderr,"%s:\n",argv[0]);
    fprintf(stderr,"%s:   -px.x    Pause for x.x seconds between frames\n",argv[0]);
    fprintf(stderr,"%s:   -o       Overlay map in /usr/local/lib/viewsat/coast\n",argv[0]);
    fprintf(stderr,"%s:   -gn      Overlay grid every n degrees\n",argv[0]);
    fprintf(stderr,
        "%s:              acceptable n's: 1,2,5,0(=10),'e'(=equator),'n'(=none)\n"
        ,argv[0]);

    exit(1);
  }

  /* set up display */
  image_depth = setupdisp(argv[0],WINX,WINY);

  /* make background black */
  setbackground(0);

  /* get the colors */
  ncolors = getcolors(cvals);

  if(ncolors == 2)
    BW = 1;

  if(BW)
  {
    numcolors = 5;
    for(i = 0;i < 4;i++)
      threshtemp[i] = BWthreshtemp[i];
  }

  for(i = 0; i < numcolors; i++)
    if(!BW)
      colorkey[i] = cvals[colorkey[i]];
    else
      colorkey[i] = i;

  for(i = 0;i < 256;i++)
  {
    colortable[i] = colorkey[0];
    for(j = 0;j < numcolors - 1;j++)
      if(i / 2. - 80. < threshtemp[j]) colortable[i] = colorkey[j+1];
  }
  for(i = 0;i < WINY;i++)
    for(j = 0;j < WINX;j++)
    {
      color[i][j]=1;
      if (j < WINX/8) mono[i][j]=255;
    }


  for(i = 0;i < numfiles;i++)
  {
    fp = fopen(filename[i],"r");
    if(fp == (FILE*)NULL)
    {
      fprintf(stderr,"%s: Unable to open file: %s\n",argv[0],filename[i]);
      exit(1);
    }
    for(j = 0;j < SY;j++)
    {
      if(fread(inputline,1,SX,fp) != SX)
      {
        fprintf(stderr,"%s: Unable to read or unexpected EOF in: %s\n",argv[0],
            filename[i]);
        exit(1);
      }
      for(k = 0;k < SX;k++)
        color[j][k] = colortable[inputline[k]];
    }

    fclose(fp);

    if(overlayflag)
      overlay();

    if(BW)
    {
      dither(colorkey);
      tempbarBW(colorkey,40);
    }

    if(BW)
    {
      sendimage(i,0,0,WINX,WINY,mono);
    }
    else
      sendimage(i,OX,OY,WINX,WINY,color);

    tempbar(i,40);

    tickmarks(i);

    drawdate(i,WINX/2-240,25);

    /* drawkey(i,4,120); */
  }

  seconds=pausetime;
  useconds=(pausetime-seconds)*1000000;
  i = 0;

  while(1)
  {
    drawtext(i,5,15,fg(),dirname[dir+1]);
    dispimage(i);
    wait();
    i += dir;
    if(i < 0 || i >= numfiles)
    {
      i -= dir*numfiles;
      wait();
    }
  }
}

void frameadvance()
{
    i += dir;
    if(i < 0 || i >= numfiles)
      i -= dir*numfiles;
    drawtext(i,5,15,fg(),dirname[1]);
    dispimage(i);
    dir = 0;
}

overlay()
{
  fp = fopen(overlayfilename,"r");
  if(fp == (FILE*)NULL)
  {
    fprintf(stderr,"%s: unable to open overlay file %s\n","viewsat",
       overlayfilename);
    exit(1);
  }
    for(j = 0;j < SY;j++)
    {
      if(fread(inputline,1,SX,fp) != SX)
      {
        fprintf(stderr,"%s: Unable to read or unexpected EOF in: %s\n","viewsat"
            ,overlayfilename);
        exit(1);
      }
      for(k = 0;k < SX;k++)
        color[j][k] = (inputline[k] ? (BW ? 0 : cvals[1]) : color[j][k]);
    }

    fclose(fp);
}

wait()
{
  for(j = 0;j < seconds*10;j++)
  {
    usleep(100000);
    checkmouse();
  }
  usleep(useconds);
  checkmouse();
  return;
}


checkmouse()
{
  if(mouseclicked(&mousex,&mousey,&mousebutton))
    switch(mousebutton)
    {
    case 1 :
      {
        if(dir == 0)
          dir = olddir;
        else
        {
          olddir = dir;
          dir = 0;
        }
        break;
      }
    case 2 :
      {
        if(dir != 0)
        {
          dir = -dir;
          break;
        }
        else
        {
          dir = olddir;
          frameadvance();
          break;
        }
      }
    case 3 :
      exit(0);
    }
  return;
}

drawkey(image,x,y)
int image,x,y;
{
  drawtext(image,x,y,fg(),"Key");
  keysquare(image,x,y+20,colorkey[0],threshtemp[0],1000);
  for(j = 1;j < NUMCOLORS - 1;j++)
    keysquare(image,x,20*j+y+20,colorkey[j],threshtemp[j],threshtemp[j-1]);
  keysquare(image,x,20*NUMCOLORS+y,colorkey[NUMCOLORS-1],-1000,
      threshtemp[NUMCOLORS-2]);
}

keysquare(image,x,y,c,t1,t2)
int image,x,y,c,t1,t2;
{
  int size=10;
  char key[20];

  xloc[0]=x;
  yloc[0]=y+5;
  xloc[1]=x+size;
  yloc[1]=y+5;
  xloc[2]=x+size;
  yloc[2]=y-size-5;
  xloc[3]=x;
  yloc[3]=y-size-5;

  fillpoly(image,4,xloc,yloc,c);

  if(t1<-999) sprintf(key,"< %d",t2);
  else if(t2>999)  sprintf(key,">= %d",t1);
  else sprintf(key,"%d - %d",t1,t2);
  drawtext(image,x+20,y,fg(),key);

  return;
}

tempbar(image,y)
int image,y;
{
  int top=y;
  int height=20;
  int temp;
  int keypos=0;
  char tempstr[30];

  yloc[0]=top;
  yloc[1]=top;
  yloc[2]=top+height;
  yloc[3]=top+height;

  for(temp=47;temp>=-80;temp--)
  {
    xloc[0]=xloc[3]=(temp+80)*8;
    xloc[1]=xloc[2]=xloc[0]+8;
    if(!BW)
      fillpoly(image,4,xloc,yloc,colortable[(temp+80)*2]);
    if(temp==threshtemp[keypos])
    {
      if(keypos<NUMCOLORS-2) keypos++;
      sprintf(tempstr,"%d",temp);
      drawtext(image,xloc[0]-10,yloc[2]+20,fg(),tempstr);
    }
  }
  drawtext(image,442,top+height+40,fg(),"Temperature (C)");
  return;
}

tickmarks(image)
int image;
{
  int l;
  int x,y;
  int s;
  char str[10];

  drawline(image,OX-1,OY-1,OX+SX-1,OY-1,1,fg());
  drawline(image,OX+SX,OY-1,OX+SX,OY+SY-1,1,fg());
  drawline(image,OX+SX,OY+SY,OX,OY+SY,1,fg());
  drawline(image,OX-1,OY+SY,OX-1,OY,1,fg());

  for(l = lon1;l <= lon2;l++)
  {
    x=OX*1.+((SX*1./(lon2*1.-lon1*1.))*(l*1.-lon1*1.));
    s=5;
    if((l/10)*10 == l)
    {
      s = 10;
      sprintf(str,"%d",l);
      drawtext(image,x-10,OY+SY+30,fg(),str);
    }
    drawline(image,x,OY-2,x,OY-1-s,1,fg());
    drawline(image,x,OY+SY+1,x,OY+SY+s,1,fg());
    if((grid == 5 || (grid == 4 && (l/2)*2 == l) || (grid == 3 && (l/5)*5 == l)
        || (grid == 2 && (l/10)*10 == l)) && l != lon1 && l != lon2)
        drawline(image,x,OY-1,x,OY+SY,1,bg());
  }

  drawtext(image,(SX/2)-45+OX,OY+SY+50,fg(),"Longitude");

  for(l = lat1;l <= lat2;l++)
  {
    y=OY*1.+((SY*1./(lat2*1.-lat1*1.))*(lat2*1.-l*1.));
    s=5;
    if((l/10)*10 == l)
    {
      s = 10;
      sprintf(str,"%d",l);
      drawtext(image,OX-40,y+5,fg(),str);
    }
    drawline(image,OX-2,y,OX-1-s,y,1,fg());
    drawline(image,OX+SX+1,y,OX+SX+s,y,1,fg());
    if((grid == 5 || (grid == 4 && (l/2)*2 == l) || (grid == 3 && (l/5)*5 == l)
        || (grid == 2 && (l/10)*10 == l) || (grid == 1 && l == 0)) && l != lat1
        && l != lat2) drawline(image,OX-1,y,OX+SX,y,1,bg());
  }

  x = OX-60;
  y = (SY/2)+OY-48;
  drawtext(image,x,y,fg(),"L");
  drawtext(image,x,y+16,fg(),"a");
  drawtext(image,x,y+32,fg(),"t");
  drawtext(image,x,y+48,fg(),"i");
  drawtext(image,x,y+64,fg(),"t");
  drawtext(image,x,y+80,fg(),"u");
  drawtext(image,x,y+96,fg(),"d");
  drawtext(image,x,y+112,fg(),"e");

  return;
}

drawdate(image,x,y)
int image,x,y;
{
  int jday,hour,quarter,minute;
  int year,month,day;
  char str[129];
  sscanf(filename[image],"%d_%d_%d",&jday,&hour,&quarter);
  if(jday <= 31)
  {
    year = 93;
    month = 1;
    day = jday;
  }
  else if(jday <= 59)
  {
    year = 93;
    month = 2;
    day = jday-31;
  }
  else if(jday <= 90)
  {
    year = 93;
    month = 3;
    day = jday-59;
  }
  else if(jday <= 305)
  {
    year = 92;
    month = 10;
    day = jday-274;
  }
  else if(jday <= 335)
  {
    year = 92;
    month = 11;
    day = jday-305;
  }
  else
  {
    year = 92;
    month = 12;
    day = jday-335;
  }
  minute = quarter*15;

  sprintf(str,"%s  -  TOGA COARE  %2d %s, 19%2d  %2d:%2d GMT",filename[image],
      day,monthname[month-1],year,hour,minute);
  drawtext(image,x,y,fg(),str);
  return;
}

dither(c)
unsigned char c[5];
{
  int x,y,l;
  unsigned char pattern[50][2];

  pattern[c[0]][0] = 0;
  pattern[c[0]][1] = 0;

  pattern[c[1]][0] = 0;
  pattern[c[1]][1] = 85;

  pattern[c[2]][0] = 170;
  pattern[c[2]][1] = 85;

  pattern[c[3]][0] = 170;
  pattern[c[3]][1] = 255;

  pattern[c[4]][0] = 255;
  pattern[c[4]][1] = 255;



  for(x = 0;x < SX/8;x++)
    for(y = 0; y < SY;y++)
    {
      mono[y+OY][x+OX/8] = 
          pattern[color[y][8*x+7]][y%2] & 1 |
          pattern[color[y][8*x+6]][y%2] & 2 |
          pattern[color[y][8*x+5]][y%2] & 4 |
          pattern[color[y][8*x+4]][y%2] & 8 |
          pattern[color[y][8*x+3]][y%2] & 16 |
          pattern[color[y][8*x+2]][y%2] & 32 |
          pattern[color[y][8*x+1]][y%2] & 64 |
          pattern[color[y][8*x]][y%2] & 128;
    }
  return;
}

tempbarBW(c,y)
int y;
unsigned char c[5];
{
  int x,h;
  unsigned char pattern[50][2];
  int height = 20;

  pattern[c[0]][0] = 0;
  pattern[c[0]][1] = 0;

  pattern[c[1]][0] = 0;
  pattern[c[1]][1] = 85;

  pattern[c[2]][0] = 170;
  pattern[c[2]][1] = 85;

  pattern[c[3]][0] = 170;
  pattern[c[3]][1] = 255;

  pattern[c[4]][0] = 255;
  pattern[c[4]][1] = 255;


  for(x = 0;x < 128;x++)
  {
    mono[y][x] = 0;
    mono[y+height][x] = 0;
    for(h = y+1;h < y+height;h++)
      mono[h][x] =  
          pattern[colortable[x*2+1]][h%2] & 15 |
          pattern[colortable[x*2]][h%2] & 240 ;
  }
  return;
}
