/* uffix uf_data_file                                                */
/* this program attempts to fix problems in data that "follows" the  */
/* universal format data.  at the current time it only fixes errors  */
/* types known to occur.   the routines are general enough to allow  */
/* the for the addition of part to account for new errors            */
/* uffix works on files that do or don't contain the file structure  */

#include <stdio.h>
#include <ctype.h>

#define  NBUFFSIZE 50000  /* size of the buffers for files */
#define  OK        0

FILE *fopen(),*uf_file;

long atol();
short *recbuff;

main(argc,argv)
int argc;
char *argv[];
{
  int nmrd,cstat;               /* number of values form read */
  int bstruct,bflag = -1;       /* block structure info */
  int loop,status,flag;         /* eof? and misc info */
  long lsize,fno;               /* for sizes of records (in chars) */
  long pos[3],poscnt;           /* used in figuring rec size if needed */
  short ssize,ssizep;           /* size of file (in shorts) */
  char filename[82],header[9];  /* names of stuff */
  char uf[4],filenamenew[82],id;/* same */

/* check command line arguments */
  if (argc != 2) {
    fprintf(stderr,"usage: %s uf_file\n",argv[0]);
    exit(2);
  }
  strcpy(filename,argv[1]);

/* open file for read/write */
  if ((uf_file=fopen(filename,"r")) == NULL) {
    fprintf(stderr,"%s: couldn't open %s\n",argv[1],filename);
    exit(2);
  }

/* determine if record structure is present */
/*   set to beginning of file */
  rewind(uf_file);

/* assume record structure is present and read in first 8 characters */
  rewind(uf_file);
  status=fread(header,sizeof(char),8,uf_file);
  checkstatus(status,"fread");

/* do a simple check: are all of them numbers? */
  flag=0;
  for (loop=0;loop<8;loop++) {
    status=isdigit(header[loop]);
    if (status==0) ++flag;
    if (header[loop] == ' ') --flag;
  }

/* if one of the above 8 char wasn't a number then the record structure is */
/* not present or something has become seriously screwed up */
  if (flag > 0) bflag=0;
  
/* read in next two characters (should not be UF if bflag = 0) */
  status=fread(uf,sizeof(char),2,uf_file);
  checkstatus(status,"fread");
  if ((strcmp(uf,"UF") == 0)&&(bflag == -1)) {
    bflag = 1;
    header[8]='\0';
    lsize=atol(header);
    status=fread(&ssize,sizeof(short),1,uf_file);
    checkstatus(status,"fread");
  }

/* if still not identified most likely the file doesn't have record structure */
/* but check anyway */
  if (bflag <= 0) {
    bflag = -1;
    rewind(uf_file);

/* read in first two characters */
    status=fread(uf,sizeof(char),2,uf_file);
    checkstatus(status,"fread");
    if (strcmp(uf,"UF") != 0) {
      fprintf(stderr,"can't verify file as universal format. dying.\n");
      exit(2);
    }
    bflag = 0;
    status=fread(&ssize,sizeof(short),1,uf_file);
    checkstatus(status,"fread");
  }

/********************************************************************/
/* presence of record structure should be positively identified now */
/********************************************************************/

  if (bflag == 1) {
    fprintf(stderr,"file read in by rtape, using initial header as a means\n");
    fprintf(stderr,"  for additional checks.\n");
  }
  if (bflag == 0)
    fprintf(stderr,"file doen't have record structure present.\n");

/* go thru the file and check record length indicators */
  rewind(uf_file);
  bstruct=bflag*8;

/* if record structure is present */
  loop=0;
  if (bflag == 1) {
    if ((lsize%2)  != 0) {
      fprintf(stderr,"error with record sturcture size. should be an even #\n");
      fprintf(stderr,"  in order to reflect 2*number of shorts in UF file\n");
      fprintf(stderr,"  dying.\n");
    }
    if ((recbuff=(short*)malloc(sizeof(short)*(lsize/2)))==NULL) {
      fprintf(stderr,"can't allocate memory for buffers\n");
      exit(2);
    }
    while ((status=fscanf(uf_file,"%8ld",&fno)) != EOF) {
      if (fno != lsize) {
        fprintf(stderr,"irregular record size. unable to fix. dying.\n");
        exit(1);
      }

/* read in the file */
      status=fread(recbuff,sizeof(char),lsize,uf_file);

/* get UF */
      if (recbuff[0] != 21830) {
        fprintf(stderr,"UF file identification not present for part of file\n");
        fprintf(stderr,"  dying.\n");
        exit(2);
      }
      ssizep=recbuff[1];
      if ((ssizep*2) != fno) {
        fprintf(stderr,"record size error. correcting record # %d:"
           ,loop+1);
        fprintf(stderr,"   present = %d   actual = %d\n",ssizep,fno/2);
        ssizep = fno/2;
        recbuff[1]=ssizep;
      }
      fprintf(stdout,"%8d",lsize);
      fwrite(recbuff,sizeof(short),(lsize/2),stdout);
      ++loop;
    }
  }

/* if record structure is not present   read in uf */
  else if (bflag == 0) {
    poscnt=pos[0]=pos[1]=pos[2]=pos[3]=0;
    status=fread(uf,sizeof(char),2,uf_file);
    checkstatus(status,"fread");
    if (strcmp(uf,"UF") != 0) {
      fprintf(stderr,"corrupted file. dying\n");
      exit(2);
    }

/* get the positions of the first 3 finding of UF and try to determine what */
/* the record size is from this assuming that they are uniform */

/* get apparent size */
    status=fread(&ssizep,sizeof(short),1,uf_file);
    checkstatus(status,"fread");

/* before working too hard, try the apparent size given in first record and */
/* see if it works */
    rewind(uf_file);
    status=fseek(uf_file,ssizep*2,0);
    checkstatus(status,"fseek");

/* is UF present ? */
    status=fread(uf,sizeof(char),2,uf_file);
    checkstatus(status,"fread");

/* if not then figure out what the record size is then continue */
    if (strcmp(uf,"UF")!=0) {
      rewind(uf_file);
      while (poscnt < 3) {
        status=fread(&id,sizeof(char),1,uf_file);
        checkstatus(status,"fread");
        if (id == 'U') {
          status=fread(&id,sizeof(char),1,uf_file);
          checkstatus(status,"fread");
          if (id == 'F') pos[poscnt++]=ftell(uf_file)-2;
        }  
      }   
  
/* now have a list of the first three occurances of UF */
/* are they the same ? */
      if (((pos[2]-pos[1])-(pos[1]-pos[0]))!=0) {    
/* if no then dye (for the time being) */
        fprintf(stderr,"yuck.  don't like this situation. dying!\n");
        exit(2);
      }
 
/* yes, they are the same  assume that they are correct */
      else  ssizep=pos[1]/2 ;
    }  
    ssize=ssizep; 
    lsize=(long)(ssize*2);
    rewind(uf_file);
    status=OK;
    loop=0;
    if ((recbuff=(short*)malloc(sizeof(short)*ssize))==NULL) {
      fprintf(stderr,"couldn't allocate memory for buffer\n");
      exit(2);
    }
    while ((status=fread(recbuff,sizeof(short),ssize,uf_file)) != 0) {

/* get UF */
      if (recbuff[0] != 21830) {
        fprintf(stderr,"UF file id not present for part of file\n");
        fprintf(stderr,"  dying.\n");
        exit(2);
      }  
      ssizep=recbuff[1];
      if (ssizep != ssize) {
        if (loop == 0){
           fprintf(stderr,"record size error. correcting record # %d:"
           ,loop+1);
           fprintf(stderr,"   present = %d   actual = %d\n",ssizep,ssize);
       }
       recbuff[1]=ssize;
      }
      ++loop;
      fprintf(stdout,"%8d",(long)(ssize*2));
      fwrite(recbuff,sizeof(short),ssize,stdout);
    }
  }
  exit(0);
}

checkstatus(stat,com)
int stat;
char *com;
{
  if (strcmp(com,"fread")==0) {
    if (stat==0) {
      fprintf(stderr,"unexpected end of file. dying.\n");
      exit(2);
    }
    else return(OK);
  }
  if (strcmp(com,"fseek")==0) {
    if (stat == -1) {
      fprintf(stderr,"unexpected error. dying.\n");
      exit(2);
    }
    else return(OK);;
  }
  return(OK);
}
