/* getcmt.c -- This routine extracts the comment form a common data format
 * header buffer.  The number of comment lines is returned.
 * At most max lines of the header buffer will be scanned.
 */
#include <stdio.h>
#include "cdfhdr.h"
static char b1[LINE];

int getcmt(buffer,max,comment)
int max;
char buffer[][LINE],comment[][LINE];
{
  int loop,count;
  static int fatal();
/* check to see if first line starts comment */
  sscanf(buffer[0],"%s",b1);
  if (strcmp(b1,CSH) != 0) fatal();
/* count through comment */
  loop = 0;
  count = 1;
  for (;;) {
    sscanf(buffer[count],"%s",b1);
    if(strcmp(b1,PSH) == 0) break;
    if (count >= max) fatal();
    if (ETEST(count)) fatal();
    strcpy(comment[loop],buffer[count]);
    loop++;
    count++;
  }
  return(loop);
}
/* fatal error -- format problem in header buffer */
static int fatal()
{
  fprintf(stderr,"getcmt: format error in header buffer\n");
  exit(1);
}
