/* getfmt accepts a header buffer and a maximum number of lines to search
* and returns a character that indicates the format of the data file: i, f, 
* or a. It dies if the end of header was reached or if the 
* maximum number of lines was read unsuccessfully */
#include <stdio.h>
#include "cdfhdr.h"
char getfmt(buffer,max)
char buffer [][LINE];
int max;
{
	int pos;	/* line of buffer */
	int i;		/* return from stringcompare */
	char infmt;	/* input file format to return */
	char fmstr[LINE];
			/* format string */
	static int fatal();

	pos = 0;
	sscanf(buffer[pos++],"%s",fmstr);
	while((i = strcmp(fmstr,FSH)) != 0) {
		if(ETEST(pos)) {fprintf(stderr,"eof "); fatal();}
		if(pos > max) fatal();
		sscanf(buffer[pos++],"%s",fmstr);
	}	
	sscanf(buffer[pos++],"%s",fmstr);
	if((i = strcmp(fmstr,"int")) == 0)
		infmt = 'i';
	else if((i = strcmp(fmstr,"float")) == 0)
		infmt = 'f';
	else if((i = strcmp(fmstr,"ascii")) == 0)
		infmt = 'a';
	else
		fatal();
	return(infmt);
}

/* fatal error -- format problem in header buffer */
static int fatal()
{
  fprintf(stderr,"getfmt: format error in header buffer \n");
  exit(1);
}
