/* getpar.c -- This routine scans through a common data format header
 * buffer looking for a parameter in a specified position.
 * If found, it puts the parameter name and its value in pname and
 * value, and returns OK.  At most, max lines
 * of the buffer will be scanned.  If the end of the buffer is actually
 * reached, a format error in the header exists.  This causes a fatal
 * error.  If no parameter exists in that position, FAIL is returned.
 */
#include <stdio.h>
#include "cdfhdr.h"
static char b1[LINE],b2[LINE];
int getpar(buffer,max,pos,pname,value)
int pos,max;
char buffer[][LINE],pname[],value[];
{
  int loop,count;
  static int fatal();
  count = 0;
/* find parameter area of buffer */
  for (;;) {
    if (count >= max) fatal();
    if (ETEST(count)) fatal();
    sscanf(buffer[count],"%s",b1);
    count++;
    if (strcmp(b1,PSH) == 0) break;
  }
/* count through parameter list */
  for (loop = 0; loop <= pos; loop++) {
    if (count >= max) fatal();
    if (ETEST(count)) fatal();
    sscanf(buffer[count],"%s %s",b1,b2);
    if (strcmp(b1,SSH) == 0) return(FAIL);
    count++;
  }
  strcpy(pname,b1);
  strcpy(value,b2);
  return(OK);
}
/* fatal error -- format problem in header buffer */
static int fatal()
{
  fprintf(stderr,"getpar: format error in header buffer\n");
  exit(1);
}
